import com.ms.xml.ParseException;
import com.ms.xml.Document;
import com.ms.xml.Element;

import java.util.Enumeration;
import java.awt.*;
import java.net.*;
import java.applet.Applet;

public class fontsize extends Applet{

    Button button1;
    String filename;
    static String displayStrings[] = new String[100];
    static int displayAttributes[] = new int[100];
    static int numberDisplayLines = 0;

    public static void main(String args[])
    {
        fontsizeFrame frame = new fontsizeFrame("The fontsize application");

        frame.show();
        frame.hide();
        frame.resize(320, 240);

        fontsize applet = new fontsize();

        frame.add("Center", applet);
        applet.init();
        applet.start();
        frame.show();
    }

    public void init(){
        button1 = new Button("Browse");
        add(button1);
    }

    public boolean action (Event e, Object o){

        URL url = null;
        filename = "file:////c://xml//fontsize//fontsize.xml";

        try {
            url = new URL(filename);
        } catch (MalformedURLException e1) {
            System.out.println("Cannot create URL for: " + filename);
            System.exit(0);
        }
            
        Document d = new Document(); 

        try {
            d.load(url);
        } 
        catch (ParseException e2) {
                d.reportError(e2, System.out);
        }
        
        if (d != null) {
            doTree(d.getRoot(), 0);
            repaint();
        }
        return true;
    }


    void doTree(Element elem, int currentfontsize)
    {
        Enumeration enum = elem.getChildren();

        while (enum.hasMoreElements()) {

            Element elem2 = (Element)enum.nextElement();
            if(elem2.getType() != com.ms.xml.Element.ELEMENT){

                displayStrings[numberDisplayLines] = elem2.getText();
                displayAttributes[numberDisplayLines++] = currentfontsize;

            }
            else{

                int oldfontsize = currentfontsize;
                if(elem2.getTagName().equals("BIGFONT")){
                    currentfontsize = 24;
                }
                if(elem2.getTagName().equals("SMALLFONT")){
                    currentfontsize = 12;
                }
                doTree(elem2, currentfontsize);
                currentfontsize = oldfontsize;

            }
        }
    }

    public void paint(Graphics g)
    {
        int y = 0;

        for(int index = 0; index < numberDisplayLines; index++){

            Font font;
            int type = Font.PLAIN;
            font = new Font("Roman", Font.PLAIN, displayAttributes[index]);
            g.setFont(font);
            FontMetrics fontmetrics = getFontMetrics(font);
            y += fontmetrics.getHeight();

            g.drawString(displayStrings[index], 0, y);

        }
    }
}    

class fontsizeFrame extends Frame
{
    public fontsizeFrame(String str)
    {
        super (str);
    }

    public boolean handleEvent(Event evt)
    {
        switch (evt.id)
        {
            case Event.WINDOW_DESTROY:
                dispose();
                System.exit(0);
                return true;

            default:
                return super.handleEvent(evt);
        }             
    }
}

